//Graphical Display List


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include "listlib.h"

#define MAXOBJECTS 20

//   
void new_display(list *l[],int *p_cnt);
void edit_display(list *l[],int *p_cnt);
void close_display();
void add_line();
void add_circle();
void add_rectangle();
void add_mark();
void set_translate();
void print_display(list *l[],int *p_cnt);
void quit();

main()
{

// menuoptions
	static struct menuoptions  {
   	char *string;
      void (*f)();
   }

   menu [] = {
   	{"Create a new display list",new_display},
      {"Edit a display list", edit_display},
      {"Close current list",close_display},
      {"Add a line", add_line},
      {"Add a circle",add_circle},
      {"Add a rectangle", add_rectangle},
      {"Add a marker", add_mark},
      {"Set translation",set_translate},
      {"Print display list",print_display},
      {"Exit the program",quit}
      };

      int menusize=sizeof(menu)/sizeof(struct menuoptions);
      list *display_lists[MAXOBJECTS];
      int listcnt=0;
      int i,choice;

      display_init();

      while (TRUE) {
      	for (i=0; i < menusize; i++) {
         	fprintf(stderr, "\t%d -- %s\n", i+1,menu[i].string);
         }
         fprintf(stderr,"Enter your choice: ");
         //     choice
         scanf("%d",&choice);
         if (choice>0 && choice <= menusize){
         	(*menu[choice-1].f)(display_lists,&listcnt);
         }
      }
   };

//  
   void new_display(list *l[],int *p_cnt)
   {
   	if (*p_cnt==MAXOBJECTS) {
      	fprintf(stderr, "Can't create any more display lists\n");
         return;
      }
      l[*p_cnt]=newobject();
      if (l[*p_cnt]==NULL) {
      	fprintf(stderr,"Creation of new display list failed!\n");
         return;
      }
      (*p_cnt)++;
      fprintf(stderr,"New display list is %\n",*p_cnt);
   };

//  
   void edit_display(list *l[],int *p_cnt)
   {
   	int listno,markno, ins_rep;
      int rc;

      if(*p_cnt==0) {
      	fprintf(stderr,"No lists to edit\n");
         return;
      }
      do {
      	fprintf(stderr,"Which list to edit (1-%d)?",*p_cnt);
         scanf("%d",&listno);
      } while (listno<1||listno>*p_cnt);
      fprintf(stderr,"Edit beginig at what marker number");
      scanf("%d",&markno);
      do {
      	fprintf(stderr,"0--replace existing primitives whith new\n");
         fprintf(stderr,"1--insert new before existing primitives\n");
         fprintf(stderr,"Enter your choice: ");
         scanf("%d",&ins_rep);
      } while (ins_rep !=1);
      rc=editobject(l[listno-1],markno,
      					(ins_rep==0)?EDIT_REPLACE:EDIT_INSERT);
      if (rc) {
      	fprintf(stderr,"display error :%s\n", display_error(rc));
      }
   } ;

//   
   void close_display()
   {
   	endobject();
   };

//   
   void add_line()
   {
   	int x1,y1,x2,y2;
      int rc;

      fprintf(stderr,"Enter the endpoints of the line in the form x1,y1,x2,y2\n");
      fprintf(stderr," (example:0,0,10,0):");
      scanf("%d,%d,%d,%d",&x1,&y1,&x2,&y2);
      rc=line(x1,y1,x2,y2);
      if (rc!=0) {
      	fprintf(stderr,"display error :%s\n",display_error(rc));
      }
   } ;

//   
   void add_rectangle()
   {
   	int x1,y1,x2,y2;
      int rc;

      fprintf(stderr,"Enter the coordinates of opposite corners of the rectangle\n");
      fprintf(stderr,"in the form x1,y1,x2,y2(example:0,0,10,0): ");
      scanf("%d,%d,%d,%d",&x1,&y1,&x2,&y2);
      rc=rectangle(x1,y1,x2,y2);
      if (rc!=0) {
      	fprintf(stderr,"display error:%s\n",display_error(rc));
      }
   };

//  
   void add_circle()
   {
   	int x1,y1,x2,y2;
      int rc;

      fprintf(stderr,"Enter the coordinates of center and radius ain the form x,y,r\n");
      fprintf(stderr," (:0,0,10):");
      scanf("%d,%d,%d",&x1,&y1,&x2);
      rc=circle(x1,y1,x2);
      if (rc!=0) {
      	fprintf(stderr,"display error: %\n",display_error(rc));
      }
   };

//   - 
   void add_mark()
   {
   	int x1;
      int rc;

      fprintf(stderr,"Enter marker number");
      scanf("%d",&x1);
      if (rc!=0) {
      	fprintf(stderr,"display error :%s\n",display_error(rc));
      }
   };

//
   void set_translate()
   {
   	int x,y;

      fprintf(stderr,"Enter the translation values (example :10,5): ");
      scanf("%d,%d",&x,&y);
      translate (x,y);
   };

// 
   void print_display(list *l[],int *p_cnt)

   {
   	int listno;

      if (*p_cnt==0) {
      	fprintf(stderr,"No lists to display\n");
         return;
      }
      do {
      	fprintf(stderr,"Which list to display (1-%d)?", *p_cnt);
         scanf("%d",&listno);
      } while (listno<1||listno>*p_cnt);
      drawobj(l[listno-1]);
   } ;

   void quit()
   {
   	exit(0);
   };
